module goals.

% This module contains the type declarations for building 
% goal expressions.

kind    goal            type.
kind    parameter       type.

type    noparam         parameter.
type    param           string -> parameter.

type    tt              goal.
type    ff              goal.
type    &&              goal -> goal -> goal.
type    vv              goal -> goal -> goal.
type    all             parameter -> (A -> goal) -> goal.
type    some            (A -> goal) -> goal.
type    ==>>            A -> goal -> goal.

infixl  vv              3.
infixl  &&              3.
infixr  ==>>            3.
